100 rem $$asmb=win1_bas_utl_OBF_bin,0,10
102 rem $$buff=802
104 :
106 rem Obfuscate a S*Basic source file from a tokenised _sav file
108 rem PWitte March 2001, 2oi4
110 rem V0.02, pjw, Feb  3rd 2015
112 rem V0.03, pjw, Oct 31st 2018, bugfix: tkw.bar->tkw.bor,tkw.bar->tkw.excl
114 rem V0.03, pjw, 2025 Feb 18, Obfuscate
116 rem V0.04, pjw, 2025 Feb 20, Pass2. Requires use of HOME_DIR$
118 :
120 ext_fn 'PEEKSTR$'
122 :
124 out$ = 'ram1_test_bas'
126 :
128 rem $$off
130 if peek$(\\-4, 4) = 'SBAS' then
132  lrespr home_dir$ & 'PEEKSTR_bin'
134 endif
136 rem $$on
138 :
140 if JOBID: cd = fopen("con_"): else: cd = 1
142 cls#cd
144 :
146 Init_Constants
148 :
150 print#cd; 'Output goes to'! out$
152 input#cd; 'Enter _sav file to obfuscate'\, fnm$
154 if fnm$ = '': stop
156 ch = fop_in(fnm$): if ch < 0: Bye 'Error opening ' & fnm$
158 close#ch
160 er = LoadFile(fnm$): if er < 0: Bye er, fnm$ & ' format error'
162 :
164 errs = 0
166 ch = fop_over(out$)
168 if ch < 0: Bye ch, 'Opening ' & out$
170 WIDTH#ch; 800:          rem Max output line width. Adjust if needed
172 ListProg#ch
174 close#ch
176 print#cd; 'Now doing second pass..'
178 EW home_dir$ & 'Pass2_obj'
180 Bye 0, 'All done with ' & errs & ' errors.'
182 :
184 :
186 def proc Bye(ec, txt$)
188 if ec < 0 then
190  print#cd; txt$; ':'! ec
192  beep 2000, 200
194 else
196  print#cd; txt$
198  beep 2000, 2
200 endif
202 if JOBID: PAUSE#cd: QUIT ec
204 ERT ec
206 enddef Bye
208 :
210 :
212 define procedure ListProg(cw)
214 loc scan, c%, tb%, tw%
216 rem GLOBal base, pos, pfend, Names$, set in LoadFile
218 :
220 os$ = '': llen% = 0
222 :
224 rep scan
226 if pos > pfend: exit scan
228 :
230  tb% = PEEK(pos)
232  sel on tb%
234   = tkb.space :rem spaces in the listing - two bytes: token count
236     c% = PEEK(pos + 1)
238     bput#cw; 32: rem print#cw; fill$(' ', c%);
240   = tkb.keyw     : rem all sorts of keywords:
242     tw% = PEEK(pos + 1)
244     sel on tw%
246      = tkw.end   : print#cw; 'END';
248      = tkw.for   : print#cw; 'FOR';
250      = tkw.if    : print#cw; 'IF';
252      = tkw.rep   : print#cw; 'REPeat';
254      = tkw.sel   : print#cw; 'SELect';
256      = tkw.when  : print#cw; 'WHEN';
258      = tkw.def   : print#cw; 'DEFine';
260      = tkw.proc  : print#cw; 'PROCedure';
262      = tkw.fn    : print#cw; 'FuNction';
264      = tkw.go    : print#cw; 'GO';
266      = tkw.to    : print#cw; 'TO';
268      = tkw.sub   : print#cw; 'SUB';
270      = tkw.err   : print#cw; 'ERRor';
272      = tkw.rest  : print#cw; 'RESTORE';
274      = tkw.next  : print#cw; 'NEXT';
276      = tkw.exit  : print#cw; 'EXIT';
278      = tkw.else  : print#cw; 'ELSE';
280      = tkw.on    : print#cw; 'ON';
282      = tkw.ret   : print#cw; 'RETurn';
284      = tkw.rmdr  : print#cw; 'REMAINDER';
286      = tkw.data  : print#cw; 'DATA';
288      = tkw.dim   : print#cw; 'DIM';
290      = tkw.loc   : print#cw; 'LOCal';
292      = tkw.let   : print#cw; 'LET';
294      = tkw.then  : print#cw; 'THEN';
296      = tkw.step  : print#cw; 'STEP';
298      = tkw.rem   : rem print#cw; 'REMark';
300      = tkw.mist  : print#cw; 'MISTake';
302      = remainder : print#cw; 'Unknown!';: errs = 1
304     endsel
306     if peek_w(pos + 2) <> tkweol and peek_w(pos + 2) <> tkwspace: PRINT#cw; ' ';
308 :
310   = tkb.odds     : rem all sorts of separators:
312     tw% = PEEK(pos + 1)
314     sel on tw%
316      = tkw.lequ  : print#cw; '='; :rem (LET) =
318      = tkw.coln  : print#cw; ':';
320      = tkw.hash  : print#cw; '#';
322      = tkw.comma : print#cw; ',';
324      = tkw.lpar  : print#cw; '(';
326      = tkw.rpar  : print#cw; ')';
328      = tkw.lbrc  : print#cw; '{';
330      = tkw.rbrc  : print#cw; '}';
332      = tkw.space : print#cw; ' ';: rem space (significant)
334      = tkw.eol   : print#cw;     : rem end of line
336        pos = pos + 2: rem Skip line length
338        rem pause
340      = remainder : print#cw; '!';:     errs = 2
342     endsel
344 :
346   = tkb.oper     : rem all sorts of operators:
348     tw% = PEEK(pos + 1)
350     sel on tw%
352      = tkw.plus  : print#cw; '+';
354      = tkw.minus : print#cw; '-';
356      = tkw.mulf  : print#cw; '*';
358      = tkw.divf  : print#cw; '/';
360      = tkw.ge    : print#cw; '>=';
362      = tkw.gt    : print#cw; '>';
364      = tkw.apeq  : print#cw; '==';
366      = tkw.eq    : print#cw; '=';
368      = tkw.ne    : print#cw; '<>';
370      = tkw.le    : print#cw; '<=';
372      = tkw.lt    : print#cw; '<';
374      = tkw.bor   : print#cw; '||';
376      = tkw.band  : print#cw; '&&';
378      = tkw.bxor  : print#cw; '^^';
380      = tkw.power : print#cw; '^';
382      = tkw.cnct  : print#cw; '&';
384      = tkw.or    : print#cw; 'OR';
386      = tkw.and   : print#cw; 'AND';
388      = tkw.xor   : print#cw; 'XOR';
390      = tkw.mod   : print#cw; 'MOD';
392      = tkw.div   : print#cw; 'DIV';
394      = tkw.instr : print#cw; 'INSTR';
396      = remainder : print#cw; '?!';:    errs = 3
398     endsel
400
402   = tkb.mon  : rem Monadic
404     tw% = PEEK(pos + 1)
406     sel on tw%
408      = tkw.neg   : print#cw; '-'; :rem negate
410      = tkw.pos   : print#cw; '+'; :rem positivel!
412      = tkw.bnot  : print#cw; '~~';
414      = tkw.not   : print#cw; 'NOT';
416      = 0         : print#cw; '?'; :rem No qualifyer?
418      = remainder : print#cw; ,tw%, :   errs = 4
420     endsel
422
424 :
426   = tkb.seps  : rem all sorts of formatting separators:
428     tw% = PEEK(pos + 1)
430     sel on tw%
432      = tkw.scoma : print#cw; ','; :rem separator comma
434      = tkw.scoln : print#cw; ';'; :rem semicolon
436      = tkw.bslsh : print#cw; '\'; :rem backslash
438      = tkw.excl  : print#cw; '!'; :rem excamation mark
440      = tkw.sto   : print#cw; 'TO'; :rem separator TO
442      = remainder : print#cw; '?'; :    errs = 5
444     endsel
446
448 :
450   = tkb.qstr  : rem delimited strings
452     tw% = PEEK(pos + 1)
454     sel on tw%
456      = tkw.quote : rem string delimited by "quotes"
458        print#cw; ;'"'; GetText$; '"';
460      = tkw.apost : rem string delimited by 'apostrophes'
462        print#cw; "'"; GetText$; "'";
464      = remainder: print#cw; 'What is this?'; : errs = 6
466     endsel
468
470 :
472   = tkb.text  : rem text (after REMark)
474     t$ = GetText$: rem print#cw; GetText$;
476
478   = tkb.lno   : rem line number (word)
480     pos = pos + 2: lnum% = peek_w(pos)
482     print#cw; lnum%; ' ';
484
486   = tkb.name  : rem name
488     pos = pos + 2
490     print#cw; Aname$(peek_w(pos));
492
494   = $d0 to $df: rem %
496     print#cw; GetFloat;:    rem GetInt$;
498
500   = $e0 to $ef: rem $
502     print#cw; GetFloat; :   rem GetHex$;
504
506   = $f0 to $ff: rem Start of literal float
508     print#cw; GetFloat;
510
512   = remainder
514     if lnum% <> 0 then
516      errs = 9
518      print#cd; '"'; lnum%! hex$(tb%, 8); '???"'; : rem ???
520     endif
522  endsel
524  pos = pos + 2
526 endrep scan
528 enddef
530 :
532 define function GetText$
534 loc l%, t$
536 pos = pos + 2
538 t$ = peekstr$(pos): l% = len(t$)
540 pos = pos + ((l% + 1 ) && -2)
542 ret t$
544 enddef
546 :
548 DEFine FuNction GETfloat
550 LOCal x%, m
552 x% = PEEK_W(pos) && 4095
554 m = PEEK_L(pos + 2)
556 pos = pos + 4
558 IF x% = 0 OR m = 0: RETurn 0
560 RETurn m * 2 ^ (x% - 2079)
562 END DEFine GETfloat
564 :
566 DEFine FuNction LoadFile(fnm$)
568 LOCal i%, m%, nts%, fl, sz, t$
570 REMark GLObal ncount%, ntsize, pfend, lcount%
572 REMark Lbytes file in a heap
574 REMark Check flag and get header details
576 REMark Set up data structures (arrays)
578 REMark Copy name list into new table
580 REMark V0.02 Without fstrg
582 :
584 REMark Load file
586 fl = flen(\ fnm$)
588 base = ALCHP(fl): IF base = 0: base = -3
590 IF base < 0: RETurn base
592 LBYTES fnm$, base
594 :
596 REMark Get and check header
598 m%      = PEEK_W(base): REMark Get magic
600   IF m% <> 20785: print#cd; '$5131 = "Q1": Wrong version?': ret -19
602 m%      = PEEK_W(base + 2): REMark Get version(?)
604   IF m% <> 896 AND m% <> 960 AND m% <> 1024 then
606    print#cd; '+++ Error: Unknown QSAVEd version(?):'! HEX$(m%,16)
608    ret -19
610   endif
612 ncount% = PEEK_W(base + 4): REMark Get number of names
614 nts%    = PEEK_W(base + 6): REMark Get size of name table. (Unsigned?)
616 REMark lcount% = peek_w(base + 8): rem Get number of lines
618 :
620 REMark Init globals
622 DIM Names$(ncount%, 20), Types%(ncount%): REMark , Deflin%(ncount%)
624 Dim Aname$(ncount%, 20)
626 IF nts% < 0: ntsize = Unsign + nts%: ELSE : ntsize = nts%
628 pfend   = base + fl
630 pos     = base + 10
632 :
634 REMark Get name table
636 sz = base + ntsize + 2: REMark ??
638 FOR i% = 0 TO ncount% - 1
640  IF pos > sz: fl = -10: EXIT i%: REMark Error EF
642  Types%(i%) = PEEK_W(pos): REMark Deflin%(i%) = peek_w(pos + 2)
644  REMark if m% < 0: Types%(i%) = m% - Unsign: else: Types%(i%) = m%
646  t$ = PEEKSTR$(pos + 4): m% = (LEN(t$) + 7) && -2
648  Names$(i%) = t$: REMark To avoid truncating of names
650  t% = Types%(i%) && $0FFF
652  sel on t%: = $0800, $0900: Aname$(i%) = Names$(i%): rem procedure/function
654  t% = t% && $000F
656  sel on t%
658     = 1: Aname$(i%) = 'V' & i% & '$'
660     = 2: Aname$(i%) = 'V' & i%
662     = 3: Aname$(i%) = 'V' & i% & '%'
664  endsel
666  pos = pos + m%: REMark Compensate for odd byte
668 END FOR i%
670 RETurn fl
672 END DEFine LoadFile
674 :
676 define procedure Init_Constants
678 bv_pfbas     = $10   : rem Start of program file
680 bv_pfp       = $14   : rem Pointer to top of program area
682 bv_ntbas     = $18   : rem Name Table (NT)
684 bv_nlbas     = $20   : rem Name list
686
688 tkb.space    = $80   : rem spaces in the listing - two bytes: token count
690
692 tkb.keyw     = $81   : rem all sorts of keywords:
694 tkw.end      = $01   : rem END
696 tkw.for      = $02   : rem FOR
698 tkw.if       = $03   : rem IF
700 tkw.rep      = $04   : rem REPeat
702 tkw.sel      = $05   : rem SELect
704 tkw.when     = $06   : rem WHEN
706 tkw.def      = $07   : rem DEFine
708 tkw.proc     = $08   : rem PROCedure
710 tkw.fn       = $09   : rem FuNction
712 tkw.go       = $0a   : rem GO
714 tkw.to       = $0b   : rem TO
716 tkw.sub      = $0c   : rem SUB
718 tkw.err      = $0e   : rem ERRor
720 tkw.rest     = $11   : rem RESTORE
722 tkw.next     = $12   : rem NEXT
724 tkw.exit     = $13   : rem EXIT
726 tkw.else     = $14   : rem ELSE
728 tkw.on       = $15   : rem ON
730 tkw.ret      = $16   : rem RETurn
732 tkw.rmdr     = $17   : rem REMAINDER
734 tkw.data     = $18   : rem DATA
736 tkw.dim      = $19   : rem DIM
738 tkw.loc      = $1a   : rem LOCal
740 tkw.let      = $1b   : rem LET
742 tkw.then     = $1c   : rem THEN
744 tkw.step     = $1d   : rem STEP
746 tkw.rem      = $1e   : rem REMark
748 tkw.mist     = $1f   : rem MISTake
750
752 tkb.odds     = $84   : rem all sorts of separators:
754 tkw.lequ     = $01   : rem (LET) =
756 tkw.coln     = $02   : rem :
758 tkw.hash     = $03   : rem #
760 tkw.comma    = $04   : rem ,
762 tkw.lpar     = $05   : rem )
764 tkw.rpar     = $06   : rem (
766 tkw.lbrc     = $07   : rem {
768 tkw.rbrc     = $08   : rem }
770 tkw.space    = $09   : rem space (significant)
772 tkw.eol      = $0a   : rem end of line
774
776 tkwspace     = $8409 - 65536 : rem cope with unsigned
778 tkweol       = $840a - 65536
780
782 tkb.oper     = $85   : rem all sorts of operators:
784 tkw.plus     = $01   : rem +
786 tkw.minus    = $02   : rem -
788 tkw.mulf     = $03   : rem *
790 tkw.divf     = $04   : rem /
792 tkw.ge       = $05   : rem >=
794 tkw.gt       = $06   : rem >
796 tkw.apeq     = $07   : rem ==
798 tkw.eq       = $08   : rem =
800 tkw.ne       = $09   : rem <>
802 tkw.le       = $0a   : rem <=
804 tkw.lt       = $0b   : rem <
806 tkw.bor      = $0c   : rem ||
808 tkw.band     = $0d   : rem &&
810 tkw.bxor     = $0e   : rem ^^
812 tkw.power    = $0f   : rem ^
814 tkw.cnct     = $10   : rem &
816 tkw.or       = $11   : rem OR
818 tkw.and      = $12   : rem AND
820 tkw.xor      = $13   : rem XOR
822 tkw.mod      = $14   : rem MOD
824 tkw.div      = $15   : rem DIV
826 tkw.instr    = $16   : rem INSTR
828
830 tkb.mon      = $86
832 tkw.neg      = $01   : rem negate
834 tkw.pos      = $02   : rem positivel!
836 tkw.bnot     = $03   : rem ~~
838 tkw.not      = $04   : rem ~
840
842 tkb.name     = $88   : rem $8800 name
844
846 tkb.qstr     = $8b   : rem delimited strings
848 tkw.quote    = $22   : rem string delimited by "quotes"
850 tkw.apost    = $27   : rem string delimited by 'apostrophes'
852
854 tkb.text     = $8c   : rem text (after REMark)
856 tkw.text     = $00   : rem text (after REMark)
858
860 tkb.lno      = $8d   : rem $8d00 line number (word)
862
864 tkb.seps     = $8e   : rem all sorts of formatting separators:
866 tkw.scoma    = $01   : rem separator comma
868 tkw.scoln    = $02   : rem semicolon
870 tkw.bslsh    = $03   : rem backslash
872 tkw.excl     = $04   : rem exclamation mark
874 tkw.sto      = $05   : rem separator TO
876 enddef
878 :
880 :
